package com.fxy.detection;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.elvishew.xlog.XLog;
import com.fxy.R;
import com.fxy.baselibrary.base.BaseActivity;
import com.fxy.baselibrary.bean.BaseEventBusBean;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.qrcode.ActivityScanerCode;
import com.fxy.baselibrary.util.JsonUtil;
import com.fxy.bean.ActionBean;
import com.fxy.bean.ScanBean;
import com.fxy.constant.BaseConfig;
import com.fxy.constant.EventCode;
import com.fxy.detection.bean.TrackingBoxBean;
import com.fxy.detection.bean.TrayMakeBean;
import com.fxy.net.MyDialogCallback;
import com.fxy.net.Urls;
import com.fxy.view.FloatingImageView;
import com.google.gson.Gson;
import com.google.zxing.Result;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import sto.android.app.StoJNI;
import sto.android.app.StoPdaKeyEvent;
import sto.android.app.StoTongJNI;

public class TrayMakeMainActivity extends BaseActivity implements StoJNI.ScanCallBack {
    /**
     * 列表适配器
     */
    Context mContext = this;

    //单号
    @BindView(R.id.et_tracking_number)
    EditText etTrackingNumber;

    //扫码扫码动作
    private ScanBean scanBean;

    //浮动按钮
    @BindView(R.id.iv_drag)
    FloatingImageView iv_drag;
    

    private Unbinder unbinder;
    

    @Override
    public int getContentViewResId() {
        return R.layout.activity_fxy_detection_tray_make;
    }

    @Override
    public boolean showToolBar() {
        return true;
    }

    @Override
    public boolean openEventBus() {
        return true;
    }

    @Override
    protected void getBundleExtras(Bundle bundle) {

    }

    //finish的返回监听
    //这里的requestCode参数，就是上面设置的 1 ，当跳转的页面返回的时候，通过这个加以判断
    //resultCode ,这个参数是在跳转的页面里面规定的，它也是一个int类型的标志
    //第三个参数包含了返回的值
    //如果不需要所跳转的页面返回值，也就不需要这个方法了
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 200 && resultCode == 200)//之前提到的两个标志，在这里显示出了作用
        {
            clearData();
        }
    }


    /**
     * EventBus接收信息的方法，开启后才会调用(非粘性事件)
     *
     * @param event
     */
    @Override
    protected void EventBean(BaseEventBusBean event) {
//        XLog.e("----------接收返回--------------");
//        XLog.e("接收返回："+event.getEventCode());
        if (event != null && event.getEventCode() == EventCode.displacement_refresh) {

        }
    }

    @Override
    public boolean isPlayMusic() {
        return true;
    }

    @Override
    protected void initView() {
        unbinder = ButterKnife.bind(this);
        setTitleName("托盘清点");

        initAdapter();
        initData();
        initEdit();
        //监听浮动按钮
        iv_drag.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!iv_drag.isDrag()) {
                    ActivityScanerCode.setScanerListener(mScanerListener);
                    ActivityScanerCode.intent2Activity(mContext, BaseConfig.COMMON_SCANNER_ONLY);
                }
            }
        });



    }


    private void initData() {

    }

    private void initAdapter() {


    }


    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //XLog.e("event:"+event.getKeyCode());
//        if ((event.getKeyCode()==KeyEvent.KEYCODE_DPAD_CENTER )  && event.getAction() == KeyEvent.ACTION_DOWN){
//            //按确定键
//            if(validate()){
//                doPutIn();
//            }
//            return true;
//        }
        return super.dispatchKeyEvent(event);
    }

    //监听按键
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        //XLog.e("监听按键："+keyCode);XLog.e(event);
        if (scanBean.getIsBroadcast() == 0 && StoTongJNI.getIns(mContext).getEventFuction(keyCode) == StoPdaKeyEvent.KEYCODE_SCAN
                && event.getRepeatCount() == 0) {

            if (StoTongJNI.getIns(mContext).GetScannerIsScanning()) {
//
            } else {
                StoTongJNI.getIns(mContext).SetScannerStart();
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @SuppressLint("HandlerLeak")
    Handler scanHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            // TODO Auto-generated method stub
            if (msg.obj != null) {

                String scanResult = msg.obj.toString().trim();
                if (!scanResult.isEmpty()) {
                    setScanResult(scanResult);
                }
            }

        }

    };

    @Override
    public void onScanResults(String str) {
        Message msg = new Message();
        msg.obj = str;
        scanHandler.sendMessage(msg);


    }


    @Override
    public void onScanResults(String str, int type) {

    }

    /**
     * 定义广播接受
     */
    BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String scanResult = intent.getStringExtra(scanBean.getDataName());
            if (scanResult == null) {
                return;
            }
            String scanStatus = "";
            if (!scanBean.getStatusName().isEmpty()) {
                scanStatus = intent.getStringExtra(scanBean.getStatusName());
            } else {
                scanStatus = scanResult.isEmpty() ? "" : "ok"; //有值 默认是扫码成功;
            }

            //新大陆(MT65,MT90) 需要手动关闭
            if (!scanBean.getActionStop().isEmpty()) {
                Intent stopIntent = new Intent(scanBean.getActionStop());
                mContext.sendBroadcast(stopIntent);
            }

            if ("ok".equals(scanStatus)) {
                setScanResult(scanResult);
            } else {
                showErrorToast(getString(R.string.scan_failed));
            }
        }
    };

    /**
     * 注册广播
     */
    private void initReceiver() {

        try {

            String scanStr = getScanSetting();
            scanBean = JsonUtil.getObject(scanStr, ScanBean.class);
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播

            if (is_broadcast == 1) {
                IntentFilter mFilter = new IntentFilter(scanBean.getAction());
                this.registerReceiver(mReceiver, mFilter);
            } else {
                //不广播进行处理 jni模式
                String pdaBrand = StoTongJNI.getmPdaBrand();
                if (!pdaBrand.isEmpty()) {
                    StoTongJNI.getIns(this).setmScanCB(this);
                    StoTongJNI.getIns(this).SetScannerOn();
                }
            }


        } catch (Exception e) {
            showErrorToast("获取扫码配置失败" + e.getMessage());
            XLog.e("获取扫码配置失败:" + e.getMessage());
        }
    }


    //统一按钮回调
    public void callbackEditor(View v) {
        switch (v.getId()) {
            case R.id.et_tracking_number:
                checkInboundPallet();
                break;

            default:
        }
    }

    private void initEdit() {
        List<EditText> list = new ArrayList<>();
        list.add(etTrackingNumber);
        unifyEdit(list);
    }

    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            String scanResult = result.getText();
            switch (type) {
                case BaseConfig.COMMON_SCANNER_ONLY:
                    setScanResult(scanResult);

                    break;
            }
        }

        @Override
        public void onFail(String type, String message) {

        }
    };

    //把扫描结果赋值
    private void setScanResult(String scanResult) {
        //获取焦点的view对象
        View view = getWindow().getDecorView().findFocus();
        //如果是EditText
        if (view instanceof EditText) {
            ((EditText) view).setText(scanResult);
            //执行回调
            callbackEditor(view);
        }
    }


    /**
     * 检查托盘
     */
    private void checkInboundPallet() {
        if (!checkNull(etTrackingNumber)) {
            setEditTextFocused(etTrackingNumber, true);
            showWarningToast(etTrackingNumber.getHint().toString());
            return ;
        }
        String postJson = formatParam();
        if (!checkRepeat(Urls.FXY_DETECTION_PALLET + (postJson))) {
            return;
        }
        OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_DETECTION_PALLET).upJson(postJson)
                .execute(new MyDialogCallback(this, true, true) {
                    @Override
                    public void onSuccess(Response<String> response) {
                        super.onSuccess(response);
                        try {
                            ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);

                            TrayMakeBean trayMakeBean = new TrayMakeBean();
                            if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                trayMakeBean =  JsonUtil.jsonString2Bean(bean.data,TrayMakeBean.class);
                            }

                            if (!trayMakeBean.getTrackingNumber().isEmpty()){
                                etTrackingNumber.setText(trayMakeBean.getTrackingNumber());
                            }

                            final Bundle bundle = new Bundle();
                            bundle.putString("data",bean.data);

                            if (trayMakeBean.getNeedConfirm().equals("Y")){
                                new AlertDialog.Builder(mContext).setTitle(R.string.dl_hint)
                                        .setMessage(trayMakeBean.getConfirmMsg())
                                        .setNegativeButton(R.string.str_cancel, new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialogInterface, int i) {
                                                dialogInterface.dismiss();
                                                etTrackingNumber.selectAll();
                                            }
                                        }).setPositiveButton(R.string.str_submit, new DialogInterface.OnClickListener() {

                                    @Override
                                    public void onClick(DialogInterface dialogInterface, int i) {
                                        intentPageResult(TrayMakeMainActivity.this, TrayMakeSecondMainActivity.class, bundle,200);
                                    }
                                }).show();
                            }else{
                                String voiceName = trayMakeBean.getVoiceName();
                                if(bean.code == 1){
                                    showSuccessToast(bean.msg,voiceName);
                                    intentPageResult(TrayMakeMainActivity.this, TrayMakeSecondMainActivity.class, bundle,200);
                                }else{
                                    showWarningToast(bean.msg,voiceName);
                                }
                            }


                        } catch (Exception e) {
                            e.printStackTrace();
                            XLog.e("请求返回箱号检查错误", e.getMessage());
                        }
                    }
                });
    }

    /**
     * 完成
     */
    private void finished() {
        clearData();
    }


    private String formatParam() {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("tracking_number", etTrackingNumber.getText().toString().trim());
            jsonObject.put("is_check", 1);
        } catch (Exception e) {
            e.printStackTrace();
            XLog.e("组装数据失败");
        }
        return jsonObject.toString();
    }



    //清除订单信息
    private void clearData() {
        etTrackingNumber.setText("");
        setEditTextNormal(etTrackingNumber, true);
        etTrackingNumber.requestFocus();
    }

    @OnClick({})
    public void onViewClicked(View view) {
        Bundle bundle = new Bundle();
        switch (view.getId()) {
            default:
                break;
        }
    }

    /**
     * 统一设置Edit监听
     *
     * @param list
     */
    public void unifyEdit(List<EditText> list) {
        for (int i = 0; i < list.size(); i++) {
            EditText editText = list.get(i);

            LinearLayout linearLayout = (LinearLayout) editText.getParent();
            ImageButton imageButton = getChildImageButton(linearLayout);


            //监听按确定
            editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
                @Override
                public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                    XLog.e("actionId：" + actionId);
                    if (event != null) {
                        XLog.e("KeyCode:" + event.getKeyCode() + "--ActionCode:" + event.getAction());
                    }

                    //|| (actionId == KeyEvent.ACTION_DOWN && event.getKeyCode()==KeyEvent.KEYCODE_ENTER )
                    if (actionId == EditorInfo.IME_ACTION_SEND || actionId == EditorInfo.IME_ACTION_DONE ||
                            (actionId == KeyEvent.ACTION_DOWN && event.getKeyCode() == KeyEvent.KEYCODE_ENTER)) {
                        if (v.getText().toString().trim().isEmpty()) {
                            setEditTextFocused(v, true);
                            showWarningToast(v.getHint().toString());
                            return true;
                        } else {
                            setEditTextNormal(v, true);
                        }
                        callbackEditor(v);
                        return false;
                    }
                    return false;

                    //返回true，保留软键盘。false，隐藏软键盘
                }
            });
            editText.addTextChangedListener(new TextWatcher() {
                public void onTextChanged(CharSequence s, int start, int before, int count) {
                    EditText currentEditText = null;
                    ImageButton currentImage = null;
                    //获取焦点的view对象
                    View view = getWindow().getDecorView().findFocus();
                    //如果是EditText
                    if (view instanceof EditText) {
                        currentEditText = (EditText) view;
                        currentImage = getChildImageButton((LinearLayout) currentEditText.getParent());
                    }

                    if (s.length() > 0) {

                        if (currentImage != null) {
                            currentImage.setVisibility(View.VISIBLE);
                        }
                        if (currentEditText != null) {
                            setEditTextNormal(currentEditText, true);
                        }

                    } else {
                        if (currentImage != null) {
                            currentImage.setVisibility(View.INVISIBLE);
                        }
                        if (currentEditText != null) {
                            setEditTextFocused(currentEditText, true);
                        }
                    }
                }

                public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                }

                public void afterTextChanged(Editable s) {

                }
            });

            if (imageButton != null) {
                unifyClearEdit(imageButton);
            }
        }
    }


    @Override
    protected void onDestroy() {
        unbinder.unbind();


        super.onDestroy();
    }

    @Override
    protected void onResume() {
        super.onResume();
        initReceiver();
    }

    @Override
    protected void onPause() {
        super.onPause();
        //销毁在onResume()方法中的广播
        try {
            //停止扫描
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播
            if (is_broadcast == 0) {
                StoTongJNI.getIns(mContext).SetScannerStop();
                StoTongJNI.getIns(mContext).SetScannerOff();
            } else {
                unregisterReceiver(mReceiver);
            }
        } catch (Exception e) {
            XLog.e("销毁广播失败：", e.getMessage());
        }
    }


}
